package com.ez.ertc.meeting.utils;
import android.text.TextUtils;
import android.util.Base64;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;
import java.util.zip.Deflater;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

/**
 * 获取rtc授权token
 */
public class ErtcGenerateTestUserSig {

    /**
     * 萤石云 SDKAppId，需要替换为您自己账号下的 SDKAppId。
     * <p>
     * 进入萤石云[控制台](https://open.ys7.com/console/account.html)
     * 点击产品中心，选择实时音视频，创建应用，即可看到 SDKAppId，
     * 它是萤石云用于区分客户的唯一标识。
     */
    private static final String SDKAPPID = "";

    /**
     * 签名过期时间，建议不要设置的过短
     * <p>
     * 时间单位：秒
     * 默认时间：7 x 24 x 60 x 60 = 604800 = 7 天
     */
    private static final int EXPIRETIME = 604800;


    /**
     * 计算签名用的加密密钥，获取步骤如下：
     * <p>
     * step1. 进入萤石云[控制台](https://open.ys7.com/console/account.html) ，如果还没有应用就创建一个，
     * step2. 单击“我的账号”，下拉列表点击“应用信息”，进入页面。
     * step3. 找到“应用密钥”部分，就可以看到计算 UserSig 使用的加密的密钥了，请将其拷贝并复制到如下的变量中
     * <p>
     * 注意：该方案仅适用于调试Demo，正式上线前请将 UserSig 计算代码和密钥迁移到您的后台服务器上，以避免加密密钥泄露导致的流量盗用。
     */
    private static final String SECRETKEY = "";

    /**
     * 计算 UserSig 签名
     * <p>
     * 函数内部使用 HMAC-SHA256 非对称加密算法，对 SDKAPPID、userId 和 EXPIRETIME 进行加密。
     *
     * @note: 请不要将如下代码发布到您的线上正式版本的 App 中，原因如下：
     * <p>
     * 本文件中的代码虽然能够正确计算出 UserSig，但仅适合快速调通 SDK 的基本功能，不适合线上产品，
     * 这是因为客户端代码中的 SECRETKEY 很容易被反编译逆向破解，尤其是 Web 端的代码被破解的难度几乎为零。
     * 一旦您的密钥泄露，攻击者就可以计算出正确的 UserSig 来盗用您的萤石云流量。
     * <p>
     * 正确的做法是将 UserSig 的计算代码和加密密钥放在您的业务服务器上，然后由 App 按需向您的服务器获取实时算出的 UserSig。
     * 由于破解服务器的成本要高于破解客户端 App，所以服务器计算的方案能够更好地保护您的加密密钥。
     * <p>
     */
    public static String genTestUserSig(String userId, String roomId) {
        return GenTLSSignature(userId, roomId, SDKAPPID, EXPIRETIME, null, SECRETKEY);
    }

    public static String genTestUserSig(String appId, String secretKey, String userId, String roomId) {
        return GenTLSSignature(userId, roomId, appId, EXPIRETIME, null, secretKey);
    }

    /**
     * 生成 tls 票据
     *
     * @param userId        用户 id
     * @param roomId        房间 id
     * @param sdkappid      应用的 appid
     * @param expire        有效期，单位是秒
     * @param userbuf       默认填写null
     * @param priKeyContent 生成 tls 票据使用的私钥内容
     * @return 如果出错，会返回为空，或者有异常打印，成功返回有效的票据
     */
    private static String GenTLSSignature(String userId, String roomId, String sdkappid, long expire, byte[] userbuf, String priKeyContent) {
        if (TextUtils.isEmpty(priKeyContent)) {
            return "";
        }
        long currTime = System.currentTimeMillis() / 1000;
        JSONObject sigDoc = new JSONObject();
        try {
            sigDoc.put("ver", "1.0");
            sigDoc.put("userid", userId);
            sigDoc.put("roomid", roomId);
            sigDoc.put("appid", sdkappid);
            sigDoc.put("expire", expire);
            sigDoc.put("time", currTime);
        } catch (JSONException e) {
            e.printStackTrace();
        }

        String base64UserBuf = null;
        if (null != userbuf) {
            base64UserBuf = Base64.encodeToString(userbuf, Base64.NO_WRAP);
            try {
                sigDoc.put("userbuf", base64UserBuf);
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
        String sig = hmacsha256(userId, roomId, sdkappid, currTime, expire, priKeyContent, base64UserBuf);
        if (sig.length() == 0) {
            return "";
        }
        try {
            sigDoc.put("sig", sig);
        } catch (JSONException e) {
            e.printStackTrace();
        }

        //json字符串进行zip压缩，然后进行base64和url编码，即可获得授权token
        Deflater compressor = new Deflater();
        compressor.setInput(sigDoc.toString().getBytes(Charset.forName("UTF-8")));
        compressor.finish();
        byte[] compressedBytes = new byte[2048];
        int compressedBytesLength = compressor.deflate(compressedBytes);
        compressor.end();
        return new String(base64EncodeUrl(Arrays.copyOfRange(compressedBytes, 0, compressedBytesLength)));
    }

    //字符串进行HmacSHA256和BASE64编码，HmacSHA256算法的SecretKey使用开发者注册应用的appSecret
    private static String hmacsha256(String userId, String roomId, String sdkappid, long currTime, long expire, String priKeyContent, String base64Userbuf) {
        String contentToBeSigned = "userid:" + userId + "\n"
                + "roomid:" + roomId + "\n"
                + "appid:" + sdkappid + "\n"
                + "time:" + currTime + "\n"
                + "expire:" + expire + "\n";
        if (null != base64Userbuf) {
            contentToBeSigned += "userbuf:" + base64Userbuf + "\n";
        }
        try {
            byte[] byteKey = priKeyContent.getBytes("UTF-8");
            Mac hmac = Mac.getInstance("HmacSHA256");
            SecretKeySpec keySpec = new SecretKeySpec(byteKey, "HmacSHA256");
            hmac.init(keySpec);
            byte[] byteSig = hmac.doFinal(contentToBeSigned.getBytes("UTF-8"));
            return new String(Base64.encode(byteSig, Base64.NO_WRAP));
        } catch (UnsupportedEncodingException e) {
            return "";
        } catch (NoSuchAlgorithmException e) {
            return "";
        } catch (InvalidKeyException e) {
            return "";
        }
    }

    private static byte[] base64EncodeUrl(byte[] input) {
        byte[] base64 = new String(Base64.encode(input, Base64.NO_WRAP)).getBytes();
        for (int i = 0; i < base64.length; ++i)
            switch (base64[i]) {
                case '+':
                    base64[i] = '*';
                    break;
                case '/':
                    base64[i] = '-';
                    break;
                case '=':
                    base64[i] = '_';
                    break;
                default:
                    break;
            }
        return base64;
    }

}